<template functional>
  <div id="class_list_wrapper">
    <div>
      <el-table :data="props.list" class="elTable-label" :empty-text="parent.$t('TEACHER_CLASS.NO_COURSE')">
        <el-table-column
          prop="index"
          label='#'
          width="50"
          align="center"
        >
          <template slot-scope="scope">
            {{ scope.$index + 1 }}
          </template>
        </el-table-column>

        <!-- <el-table-column
          prop="type"
          :label="parent.$t('TEACHER_CLASS.TYPE')"
          width="110"
          align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.type === 4">
              {{ parent.$t('TEACHER_CLASS.PUBLIC') }}
            </span>
            <span v-else>
              {{ parent.$t('TEACHER_CLASS.PRIVATE') }}
            </span>
          </template>
        </el-table-column> -->

        <el-table-column
          prop="name"
          :label="parent.$t('TEACHER_CLASS.COURSE')"
          align="left"
        >
          <template slot-scope="scope">
            <span v-if="props.type === 'ADMIN'">
              {{scope.row.name}}
            </span>
            <span v-else>
              [{{scope.row.affiliation_name}}]{{scope.row.name}}
            </span>
          </template>
        </el-table-column>

        <el-table-column
          v-if="props.type === 'ADMIN'"
          prop="users[0].name"
          :label="parent.$t('STUDENT_MENU.INSTRUCTOR')"
          align="left"
        ></el-table-column>

        <el-table-column
          :label="parent.$t('TEACHER_CLASS.PERIOD')"
          width="225"
          align="center"
        >
          <template slot-scope="scope">
            {{ scope.row.start_time ? new Date(scope.row.start_time).toLocaleDateString('ko-KR') : '미정' }} 
            ~
            {{ scope.row.end_time ? new Date(scope.row.end_time).toLocaleDateString('ko-KR') : '미정' }}
          </template>
        </el-table-column>
        
        <el-table-column
          v-if="!props.isPhone"
          label="-"
          width="145"
          align="center"
        >
          <template slot-scope="scope">
            <!-- <router-link :to="`/a/teacher/NNclass/${scope.row.class_id}/edit`">
              <el-button class="edit-btn">{{ parent.$t('TEACHER_CLASS.EDIT_COURSE') }}</el-button>
            </router-link> -->
            <el-button @click="listeners['edit'](scope.$index)" class="edit-btn">{{ parent.$t('TEACHER_CLASS.EDIT_COURSE') }}</el-button>
          </template>
        </el-table-column>


        <el-table-column
          v-if="!props.isPhone"
          label="-"
          width="200"
          align="center"
        >
          <template slot-scope="scope">
            <!-- <router-link :to="`/a/teacher/NNclass/${scope.row.class_id}/manage/enrollment`">
              <el-button class="edit-btn">{{ parent.$t('TEACHER_CLASS.MNG_ENROLL') }}</el-button>
            </router-link> -->
            <el-button @click="listeners['manage'](scope.$index)" class="edit-btn">{{ parent.$t('TEACHER_CLASS.MNG_ENROLL') }}</el-button>
          </template>
        </el-table-column>

        <el-table-column
          v-if="!props.isPhone"
          label="-"
          width="110"
          align="center"
        >
          <template slot-scope="scope">
            <el-button type="danger" @click="listeners['delete'](scope.$index)" class="delete-btn">{{ parent.$t('LECTURE_LIST.DELETE') }}</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
export default {
  name: 'ClassList',
  props: {
    type: {
      type: String,
      required: true,
      validator(value) {
        const allowedTypeList = ['TEACHER', 'STUDENT', 'ADMIN'];
        if (!allowedTypeList.includes(value)) {
          // eslint-disable-next-line no-console
          console.error(`prop "type" should be one of ${allowedTypeList}`);
          return false;
        }
        return true;
      },
    },
    list: {
      type: Array,
      required: true,
      validator(value) {
        if (!Array.isArray(value)) {
          // eslint-disable-next-line no-console
          console.error('prop "list" should be type Array');
          return false;
        }
        if (value.length === 0) {
          return true;
        }
        const firstElement = value[0];
        const allowedKeyOfClassListItem = ['id']; // TODO: improve this list
        const firstElementKeySet = new Set(Object.keys(firstElement));
        if (firstElementKeySet.size === 0) {
          throw new Error('ClassList empty element received.');
        }
        for (let i = 0; i < allowedKeyOfClassListItem; i += 1) {
          const expectedKey = allowedKeyOfClassListItem[i];
          if (!firstElementKeySet.has(expectedKey)) {
            // eslint-disable-next-line no-console
            console.error(`prop "list" should have \`${expectedKey}\``);
            return false;
          }
        }
        return true;
      },
    },
    isPhone: {
      type: null,
    },
  },
};
</script>

<style lang="scss" scoped>
#class_list_wrapper {
  .elTable-label {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    margin-bottom: 10px;
    letter-spacing: normal;
    color: #909399;
    text-align: center;
  }
  .elTable-label tr {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .elTable-label td {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #606266;
  }
  .edit-btn{
    
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #1989fa;
    
    background-color: none;
    border-color: none;
  }
}

</style>
